/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

#include "main.h"
#include "arp.h"
#include "ethernet.h"

//############################################################################
//Diese Routine erzeugt ein ARP buffer
void ARP_Reply (char *buffer,int *bufferlen)
//############################################################################
{
	struct Ethernet_Header *ethernet;
	ethernet = (struct Ethernet_Header *)&buffer[ETHER_OFFSET];

	struct ARP_Header *arp;
	arp = (struct ARP_Header *)&buffer[ARP_OFFSET];

	//2 Byte Hardware Typ: Enthlt den Code fr Ethernet
	if(arp->ARP_HWType == 0x0100 &&

	//2 Byte Protokoll Typ: Enthlt den Code fr IP
	arp->ARP_PRType == 0x0008 &&

	//1Byte Lnge der Hardwareadresse:Enthlt 6 fr 6 Byte MAC Addresse
	arp->ARP_HWLen == 0x06 && 

	//1Byte Lnge der Protokolladresse:Enthlt 4 fr 4 Byte Adressen 
	arp->ARP_PRLen == 0x04 &&
	
	//Ist das ARP Packet fr meine IP Addresse bestimmt
	//Vergleiche ARP Target IP Adresse mit meiner IP
	arp->ARP_TIPAddr == *((unsigned long *)&MYIP[0]))
	{
		if ( arp->ARP_Op == 0x0100)
		//Operation handelt es sich um eine anfrage
	
		
		{
		for(unsigned char a = 0; a < 6; a++)
			{
			//MAC Destadresse wird geschrieben mit MAC Sourceadresse
			ethernet->EnetPacketDest[a] = ethernet->EnetPacketSrc[a];
			//Meine MAC Adresse wird in Sourceadresse geschrieben
			ethernet->EnetPacketSrc[a] = mymac[a];
			//das gleiche fr die MAC Adresse
			//ARP MAC Targetadresse wird geschrieben mit ARP Sourceadresse
			arp->ARP_THAddr[a] = ethernet->EnetPacketDest[a];
			//ARP MAC Sourceadresse wird geschrieben mit My MAC Adresse
			arp->ARP_SHAddr[a] = mymac[a];
			}

		//ARP operation wird auf 2 gesetzt damit der andere merkt es ist ein ECHO	
		arp->ARP_Op = 0x0200;	
		//ARP Target IP Adresse wird geschrieben mit ARP Source IP Adresse 
		arp->ARP_TIPAddr = arp->ARP_SIPAddr;
		//Meine IP Adresse wird in ARP Source IP Adresse geschrieben
		arp->ARP_SIPAddr = *((unsigned long *)&MYIP[0]);

		//Nun ist das ARP buffer fertig zum Senden !!!
		//Sendet das erzeugte ARP Packet 
		Write_Ethernet_Frame (buffer,*bufferlen);
		}
		else
		if ( arp->ARP_Op == 0x0200)
		//Operation handelt es sich um eine antwort?
	    {
		 unsigned char index = 0xff;
		 
		for (unsigned char i=0; i<NUM_ARP_ENTRIES; i++) if (!(ARP_Table[i].MAC_Received)  && arp->ARP_SIPAddr == ARP_Table[i].IP.Long) 
		 { index = i; 
		   ARP_Table[index].MAC_Received = 1;
		   for(unsigned char a = 0; a < 6; a++)	ARP_Table[index].ARP_MAC[a] = ethernet->EnetPacketSrc[a];
		 }
		
		if (index != 0xff) 
	  	 { 
		   printf_P(PSTR("ARP: "));
		   for(unsigned char a = 0; a < 6; a++)	printf("%02X ", ARP_Table[index].ARP_MAC[a]);
	 	   printf("is %d.%d.%d.%d", ARP_Table[index].IP.Byte[0], ARP_Table[index].IP.Byte[1], ARP_Table[index].IP.Byte[2], ARP_Table[index].IP.Byte[3]);
		   	
		  printf_P(PSTR("\r\n"));
		 }
	   }
	
	}	
		return;
}

void ARP_Request(char *buffer, struct str_ARP_Table *table)
{
  	struct Ethernet_Header *ethernet;
	ethernet = (struct Ethernet_Header *)&buffer[ETHER_OFFSET];

	struct ARP_Header *arp;
	arp = (struct ARP_Header *)&buffer[ARP_OFFSET];
  
	arp->ARP_HWType = 0x0100;
	
	ethernet->EnetPacketType = 0x0608;   // ARP-Packet

    for(unsigned char a = 0; a < 6; a++)
		{ ethernet->EnetPacketSrc[a] = mymac[a];
		  ethernet->EnetPacketDest[a] = 0xff;
		  arp->ARP_SHAddr[a] = mymac[a];
		  arp->ARP_THAddr[a] = 0x00;
		  
		}  
	
	arp->ARP_SIPAddr = *((unsigned long *)&MYIP[0]);
	//arp->ARP_TIPAddr = *((unsigned long *)&ip[0]);
	 arp->ARP_TIPAddr = table->IP.Long; 
	
	//2 Byte Protokoll Typ: Enthlt den Code fr IP
	arp->ARP_PRType = 0x0008;

	//1Byte Lnge der Hardwareadresse:Enthlt 6 fr 6 Byte MAC Addresse
	arp->ARP_HWLen = 0x06;

	//1Byte Lnge der Protokolladresse:Enthlt 4 fr 4 Byte Adressen 
	arp->ARP_PRLen = 0x04;

    arp->ARP_Op = 0x0100;
	
    Write_Ethernet_Frame (buffer, 60);
	
}


